<?php

namespace App\Entity;

use ApiPlatform\Core\Annotation\ApiFilter;
use ApiPlatform\Core\Bridge\Doctrine\Orm\Filter\SearchFilter;
use ApiPlatform\Core\Serializer\Filter\PropertyFilter;
use Symfony\Component\Serializer\Annotation\Groups;

use App\Repository\TProjectsFeedbacksRepository;
use Doctrine\ORM\Mapping as ORM;
use ApiPlatform\Core\Annotation\ApiResource;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;

/**
 * @ApiResource(
 *    normalizationContext={"groups"={"t_projects_feedbacks:read"}, "enable_max_depth"="true", "swagger_definition_name"="Read"},
 *    denormalizationContext={"groups"={"t_projects_feedbacks:write"}, "swagger_definition_name"="Write"}
 * )
 * @ApiFilter(SearchFilter::class, properties={ "id": "exact", "project": "exact", "status": "exact" })
 * @ApiFilter(PropertyFilter::class)
 * @ORM\Entity(repositoryClass=TProjectsFeedbacksRepository::class)
 */

class TProjectsFeedbacks
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     * @Groups({ "t_projects_feedbacks:read", "t_projects_feedbacks:write" })
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=60, nullable=true)
     * @Groups({ "t_projects_feedbacks:read", "t_projects_feedbacks:write", "t_projects:read" })
     */
    private $fullName;

    /**
     * @ORM\Column(type="string", length=60, nullable=true)
     * @Groups({ "t_projects_feedbacks:read", "t_projects_feedbacks:write", "t_projects:read" })
     */
    private $contacts;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     * @Groups({ "t_projects_feedbacks:read", "t_projects_feedbacks:write", "t_projects:read" })
     */
    private $feedbackSubject;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     * @Groups({ "t_projects_feedbacks:read", "t_projects_feedbacks:write" })
     */
    private $feedbackImage;

    /**
     * @ORM\Column(type="text", nullable=true)
     * @Groups({ "t_projects_feedbacks:read", "t_projects_feedbacks:write" })
     */
    private $feedbackDetails;

    /**
     * @ORM\ManyToOne(targetEntity=TProjects::class, inversedBy="tProjectsFeedbacks")
     * @Groups({ "t_projects_feedbacks:read", "t_projects_feedbacks:write" })
     */
    private $project;

    /**
     * @ORM\Column(type="string", length=60, nullable=true)
     * @Groups({ "t_projects_feedbacks:read", "t_projects_feedbacks:write", "t_projects:read" })
     */
    private $feedbackType;

    /**
     * @ORM\Column(type="text", nullable=true)
     * @Groups({ "t_projects_feedbacks:read", "t_projects_feedbacks:write" })
     */
    private $feedbackResponse;

    /**
     * @ORM\Column(type="string", length=60, nullable=true)
     * @Groups({ "t_projects_feedbacks:read", "t_projects_feedbacks:write", "t_projects:read" })
     */
    private $status;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getFullName(): ?string
    {
        return $this->fullName;
    }

    public function setFullName(?string $fullName): self
    {
        $this->fullName = $fullName;

        return $this;
    }

    public function getContacts(): ?string
    {
        return $this->contacts;
    }

    public function setContacts(?string $contacts): self
    {
        $this->contacts = $contacts;

        return $this;
    }

    public function getFeedbackSubject(): ?string
    {
        return $this->feedbackSubject;
    }

    public function setFeedbackSubject(?string $feedbackSubject): self
    {
        $this->feedbackSubject = $feedbackSubject;

        return $this;
    }

    public function getFeedbackImage(): ?string
    {
        return $this->feedbackImage;
    }

    public function setFeedbackImage(?string $feedbackImage): self
    {
        $this->feedbackImage = $feedbackImage;

        return $this;
    }

    public function getFeedbackDetails(): ?string
    {
        return $this->feedbackDetails;
    }

    public function setFeedbackDetails(?string $feedbackDetails): self
    {
        $this->feedbackDetails = $feedbackDetails;

        return $this;
    }

    public function getProject(): ?TProjects
    {
        return $this->project;
    }

    public function setProject(?TProjects $project): self
    {
        $this->project = $project;

        return $this;
    }

    public function getFeedbackType(): ?string
    {
        return $this->feedbackType;
    }

    public function setFeedbackType(?string $feedbackType): self
    {
        $this->feedbackType = $feedbackType;

        return $this;
    }

    public function getFeedbackResponse(): ?string
    {
        return $this->feedbackResponse;
    }

    public function setFeedbackResponse(?string $feedbackResponse): self
    {
        $this->feedbackResponse = $feedbackResponse;

        return $this;
    }

    public function getStatus(): ?string
    {
        return $this->status;
    }

    public function setStatus(?string $status): self
    {
        $this->status = $status;

        return $this;
    }
}
